#!/bin/sh

die () {
   echo "*** mkconfig.sh: $*" 1>&2
   exit 1
}

[ -f makefile ] || die "can not find 'makefile'"

cat<<EOF
/*************************************************************/
/* Automatically generated by './mkconfig.sh': do note edit! */
/*************************************************************/
EOF

if [ ! x"`grep '^CC=gcc$' makefile`" =  x ]
then
  patchgccversion="`gcc --version|head -1|sed -e 's/,/ /g'`"
  patchgccversion="s,gcc,$patchgccversion,g"
else
  patchgccversion="s,DUMMY,DUMMY,"
fi

sed \
  -e '/^C[A-Z]*=/!d' \
  -e 's,^,#define BTOR_,' \
  -e 's,= *, ",' \
  -e 's,$,",' \
  makefile | sed -e "$patchgccversion"

echo "#define BTOR_OS \"`uname -srmn`\""
echo "#define BTOR_COMPILED \"`date`\""

curpath=`pwd`
echo "#define BTOR_SRC_DIR   \"$curpath/\""
echo "#define BTOR_BIN_DIR   \"$curpath/bin/\""
echo "#define BTOR_BUILD_DIR \"$curpath/build/\""
echo "#define BTOR_TEST_DIR  \"$curpath/src/tests/\""
echo "#define BTOR_LOG_DIR   \"$curpath/src/tests/log/\""
echo "#define BTOR_CONTRIB_DIR \"$curpath/contrib/\""

# PUT NOTHING BELOW THE NEXT COMMENT LINE ...

cat<<EOF
#define BTOR_RELEASED "Sat Dec 17 03:47:54 CET 2016"
#define BTOR_VERSION "2.3.1"
#define BTOR_ID "8d1d803857126950637a8c1e29129ad09b090441"
EOF
