/*  Boolector: Satisfiablity Modulo Theories (SMT) solver.
 *
 *  Copyright (C) 2016 Mathias Preiner.
 *
 *  All rights reserved.
 *
 *  This file is part of Boolector.
 *  See COPYING for more information on using this software.
 */

#ifndef BTORCADICAL_H_INCLUDED
#define BTORCADICAL_H_INCLUDED

#ifdef BTOR_USE_CADICAL

#include <stdio.h>

#include "btorsat.h"

void * btor_cadical_init (struct BtorSATMgr *);
void btor_cadical_add (struct BtorSATMgr *,int);
int btor_cadical_sat (struct BtorSATMgr *, int);
int btor_cadical_deref (struct BtorSATMgr *,int);
int btor_cadical_repr (struct BtorSATMgr *,int);
void btor_cadical_reset (struct BtorSATMgr *);
void btor_cadical_set_output (struct BtorSATMgr *, FILE *);
void btor_cadical_set_prefix (struct BtorSATMgr *, const char *);
void btor_cadical_enable_verbosity (struct BtorSATMgr *, int);
int btor_cadical_inc_max_var (struct BtorSATMgr *);
int btor_cadical_variables (struct BtorSATMgr *);
void btor_cadical_stats (struct BtorSATMgr *);

void btor_cadical_assume (struct BtorSATMgr *, int);
int btor_cadical_failed (struct BtorSATMgr *, int);
int btor_cadical_fixed (struct BtorSATMgr *, int);
int btor_cadical_changed (struct BtorSATMgr *);
int btor_cadical_inconsistent (struct BtorSATMgr *);

const char * btor_cadical_version (void);

#endif
#endif
